// ComLog.h : Declaration of the CComLog

#ifndef __COMLOG_H_
#define __COMLOG_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CComLog
class ATL_NO_VTABLE CComLog : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CComLog, &CLSID_ComLog>,
	public ILogbook,
   public IObjectControl,
   public IObjectConstruct
{
public:
	CComLog();
	virtual ~CComLog();
   HRESULT  FinalConstruct(void);
   void     FinalRelease(void);

DECLARE_REGISTRY_RESOURCEID(IDR_COMLOG)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CComLog)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IObjectConstruct)
	COM_INTERFACE_ENTRY(ILogbook)
END_COM_MAP()

// ILogbook
public:
	STDMETHOD(LogEvent) (LOG_ENTRY* pEventEntry);
	STDMETHOD(LogMethod)(LOG_ENTRY* pMethodEntry);
	STDMETHOD(LogError) (LOG_ENTRY* pErrorEntry);
// IObjectControl
   STDMETHOD(Activate)(void)       { return S_OK; }
   STDMETHOD_(BOOL, CanBePooled)() { return TRUE; }
   STDMETHOD_(void, Deactivate)()  { }

// IObjectConstruct
   STDMETHOD(Construct)(IDispatch* pCtorObj);

protected:
   CStdioFile m_LogFile;

   void    GetTime(const LOG_ENTRY* pEvent, SYSTEMTIME& systemTime) const;

   HRESULT WriteString(const CString& sString);
   HRESULT WriteIDS(UINT uID);
   HRESULT WriteIDS(UINT uID, const CString& sString);
   HRESULT WriteIDS(UINT uID, DWORD dwNumber);
   HRESULT WriteIDS(UINT uID, const SYSTEMTIME& systemTime);
   HRESULT WriteGUID(const CString& sNULLGUID, REFGUID guid);

   HRESULT SetTableHeader(void);
   HRESULT NewRow(const LOG_ENTRY* pEvent, CString& sTableEnd);
   HRESULT SetRowEnd(const CString& sTableEnd);
};

#endif //__COMLOG_H_
