#ifndef COM_LOG_BOOK
#define COM_LOG_BOOK

#pragma warning( disable : 4310 4244)// Disable warning messages to allow level 4 compilation
#include <comdef.h>
#pragma warning( default : 4310 4244)

#include "mtx.h"

/* verify that the <rpcndr.h> version is high enough to compile this file*/
#ifndef __REQUIRED_RPCNDR_H_VERSION__
#define __REQUIRED_RPCNDR_H_VERSION__ 440
#endif

#include "rpc.h"
#include "rpcndr.h"

#ifndef __RPCNDR_H_VERSION__
#error this stub requires an updated version of <rpcndr.h>
#endif // __RPCNDR_H_VERSION__

#ifndef COM_NO_WINDOWS_H
#include "windows.h"
#include "ole2.h"
#endif /*COM_NO_WINDOWS_H*/

#ifndef __LogBootEvent_h__
#define __LogBootEvent_h__

#ifdef __cplusplus
extern "C"{
#endif 

/* Forward Declarations */ 

#ifndef __ILogbook_FWD_DEFINED__
#define __ILogbook_FWD_DEFINED__
typedef interface ILogbook ILogbook;
#endif 	/* __ILogbook_FWD_DEFINED__ */


#ifndef __LogbookEventClass_FWD_DEFINED__
#define __LogbookEventClass_FWD_DEFINED__

#ifdef __cplusplus
typedef class LogbookEventClass LogbookEventClass;
#else
typedef struct LogbookEventClass LogbookEventClass;
#endif /* __cplusplus */

#endif 	/* __LogbookEventClass_FWD_DEFINED__ */


/* header files for imported files */
#include "oaidl.h"
#include "ocidl.h"

void __RPC_FAR * __RPC_USER MIDL_user_allocate(size_t);
void __RPC_USER MIDL_user_free( void __RPC_FAR * ); 

#ifndef __ILogbook_INTERFACE_DEFINED__
#define __ILogbook_INTERFACE_DEFINED__

/* interface ILogbook */
/* [unique][helpstring][uuid][object] */ 

typedef struct  tagLOG_ENTRY
    {
    HRESULT hres;
    DWORD dwErrorCode;
    DWORD dwProcessID;
    DWORD dwThreadID;
    GUID guidActivityID;
    GUID guidTransactionID;
    GUID guidContextID;
    BSTR bstrMachineName;
    BSTR bstrSourceFileName;
    BSTR bstrModuleName;
    BSTR bstrMethodName;
    DWORD dwLineNumber;
    BSTR bstrDescription;
    IID iidError;
    FILETIME eventTime;
    }	LOG_ENTRY;


EXTERN_C const IID IID_ILogbook;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("F6458918-791F-461B-8BE0-4F910A922B36")
    ILogbook : public IUnknown
    {
    public:
        virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE LogError( 
            /* [in] */ LOG_ENTRY __RPC_FAR *pErrorEntry) = 0;
        
        virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE LogMethod( 
            /* [in] */ LOG_ENTRY __RPC_FAR *pMethodEntry) = 0;
        
        virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE LogEvent( 
            /* [in] */ LOG_ENTRY __RPC_FAR *pEventEntry) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct ILogbookVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( 
            ILogbook __RPC_FAR * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( 
            ILogbook __RPC_FAR * This);
        
        ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( 
            ILogbook __RPC_FAR * This);
        
        /* [helpstring] */ HRESULT ( STDMETHODCALLTYPE __RPC_FAR *LogError )( 
            ILogbook __RPC_FAR * This,
            /* [in] */ LOG_ENTRY __RPC_FAR *pErrorEntry);
        
        /* [helpstring] */ HRESULT ( STDMETHODCALLTYPE __RPC_FAR *LogMethod )( 
            ILogbook __RPC_FAR * This,
            /* [in] */ LOG_ENTRY __RPC_FAR *pMethodEntry);
        
        /* [helpstring] */ HRESULT ( STDMETHODCALLTYPE __RPC_FAR *LogEvent )( 
            ILogbook __RPC_FAR * This,
            /* [in] */ LOG_ENTRY __RPC_FAR *pEventEntry);
        
        END_INTERFACE
    } ILogbookVtbl;

    interface ILogbook
    {
        CONST_VTBL struct ILogbookVtbl __RPC_FAR *lpVtbl;
    };

    

#ifdef COBJMACROS


#define ILogbook_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define ILogbook_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define ILogbook_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define ILogbook_LogError(This,pErrorEntry)	\
    (This)->lpVtbl -> LogError(This,pErrorEntry)

#define ILogbook_LogMethod(This,pMethodEntry)	\
    (This)->lpVtbl -> LogMethod(This,pMethodEntry)

#define ILogbook_LogEvent(This,pEventEntry)	\
    (This)->lpVtbl -> LogEvent(This,pEventEntry)

#endif /* COBJMACROS */


#endif 	/* C style interface */



/* [helpstring] */ HRESULT STDMETHODCALLTYPE ILogbook_LogError_Proxy( 
    ILogbook __RPC_FAR * This,
    /* [in] */ LOG_ENTRY __RPC_FAR *pErrorEntry);


void __RPC_STUB ILogbook_LogError_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


/* [helpstring] */ HRESULT STDMETHODCALLTYPE ILogbook_LogMethod_Proxy( 
    ILogbook __RPC_FAR * This,
    /* [in] */ LOG_ENTRY __RPC_FAR *pMethodEntry);


void __RPC_STUB ILogbook_LogMethod_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


/* [helpstring] */ HRESULT STDMETHODCALLTYPE ILogbook_LogEvent_Proxy( 
    ILogbook __RPC_FAR * This,
    /* [in] */ LOG_ENTRY __RPC_FAR *pEventEntry);


void __RPC_STUB ILogbook_LogEvent_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __ILogbook_INTERFACE_DEFINED__ */



#ifndef __LOGBOOTEVENTLib_LIBRARY_DEFINED__
#define __LOGBOOTEVENTLib_LIBRARY_DEFINED__

/* library LOGBOOTEVENTLib */
/* [helpstring][version][uuid] */ 


EXTERN_C const IID LIBID_LOGBOOTEVENTLib;

EXTERN_C const CLSID CLSID_LogbookEventClass;

#ifdef __cplusplus

class DECLSPEC_UUID("8AFBF443-A4CE-4947-95B4-AC87B5E0CD09")
LogbookEventClass;
#endif
#endif /* __LOGBOOTEVENTLib_LIBRARY_DEFINED__ */

/* Additional Prototypes for ALL interfaces */

unsigned long             __RPC_USER  BSTR_UserSize(     unsigned long __RPC_FAR *, unsigned long            , BSTR __RPC_FAR * ); 
unsigned char __RPC_FAR * __RPC_USER  BSTR_UserMarshal(  unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, BSTR __RPC_FAR * ); 
unsigned char __RPC_FAR * __RPC_USER  BSTR_UserUnmarshal(unsigned long __RPC_FAR *, unsigned char __RPC_FAR *, BSTR __RPC_FAR * ); 
void                      __RPC_USER  BSTR_UserFree(     unsigned long __RPC_FAR *, BSTR __RPC_FAR * ); 

/* end of Additional Prototypes */

#ifdef __cplusplus
}
#endif

#endif


const IID IID_ILogbook2 = {0xF6458918,0x791F,0x461B,{0x8B,0xE0,0x4F,0x91,0x0A,0x92,0x2B,0x36}};
const CLSID CLSID_LogbookEventClass2 = {0x8AFBF443,0xA4CE,0x4947,{0x95,0xB4,0xAC,0x87,0xB5,0xE0,0xCD,0x09}};

/////////////////////////////////////////////////////////////////////////////
// CEventLogger - a helper calls to fire the events
class CEventLogger
{
public:
   CEventLogger();
   inline virtual ~CEventLogger();

// Derived Class Helpers
   inline void DoLogMethod(const CString& sMethodName, const CString& sSourceFileName, WORD wLine) const;
   inline void DoLogError(REFIID riid, HRESULT hres, const CString& sMethodName, const CString& sError,const CString& sSourceFileName,WORD wLine, IUnknown* pUnk = NULL) const;
   inline void DoLogEvent(const CString& sEvent) const;

   static LPTSTR FindPathInFileName(LPCTSTR lpPath)
   {
       if (lpPath == NULL)
           return NULL;

       LPTSTR lpFilename = (LPTSTR)&lpPath[lstrlen(lpPath) - 1];
       BOOL bIsFile = FALSE;

       while (lpFilename > lpPath && *lpFilename != TEXT('\\'))
       {
           if (*lpFilename == TEXT('.'))
               bIsFile = TRUE;
           lpFilename--;
       }

       lpFilename++;
       if (bIsFile == TRUE)
           return lpFilename;
       return (LPTSTR)lpPath;
   }

private:
// Internal Helper functions
   inline void GetIErrorInfo(IUnknown* pUnk, CString& sDescription) const;
   inline void FillLogEntry(LOG_ENTRY* pLogEntry, const CString& sMethodName,const CString& sSourceFileName,const CString& sDescription,WORD wLine) const;
   inline void CleanLogEntry(LOG_ENTRY* pLogEntry) const;
   inline GUID GetActivityID(void) const;
   inline GUID GetTransactionID(void) const;
   inline GUID GetContextID(void) const;

   const IID IID_ILogbook;
   const CLSID CLSID_LogbookEventClass;

   IObjectContextInfo* m_pObjectContextInfo;

};

/////////////////////////////////////////////////////
//Inline implementation
inline CEventLogger::CEventLogger():m_pObjectContextInfo(NULL)
{
   ::CoGetObjectContext(IID_IObjectContextInfo,(void**)&m_pObjectContextInfo);
}
inline CEventLogger::~CEventLogger() 
{
   if(m_pObjectContextInfo != NULL)
      m_pObjectContextInfo->Release();
}

inline void CEventLogger::DoLogEvent(const CString& sEvent) const
{
   LOG_ENTRY logEntry;
   ::ZeroMemory(&logEntry, sizeof(logEntry));

   FillLogEntry(&logEntry,"An Event, not a method","File name is not available",sEvent,0);

   HRESULT    hres = S_OK;
   ILogbook* pLogbook  = NULL;

   hres = ::CoCreateInstance(CLSID_LogbookEventClass2, NULL, CLSCTX_ALL,IID_ILogbook2, (void **) &pLogbook);
   if (S_OK == hres)
   {
      hres = pLogbook->LogEvent(&logEntry);
      pLogbook->Release();
   }

   CleanLogEntry(&logEntry);
}

inline void CEventLogger::DoLogMethod(const CString& sMethodName, const CString& sSourceFileName, WORD wLine) const
{
   LOG_ENTRY logEntry;
   ::ZeroMemory(&logEntry, sizeof(logEntry));

   FillLogEntry(&logEntry, sMethodName, sSourceFileName,"No Description", wLine);
   
   HRESULT    hres = S_OK;
   ILogbook* pLogbook  = NULL;
   hres = ::CoCreateInstance(CLSID_LogbookEventClass2, NULL, CLSCTX_ALL, IID_ILogbook2, (void **) &pLogbook);
   if (S_OK == hres)
   {
      hres = pLogbook->LogMethod(&logEntry);
      pLogbook->Release();
   }

   CleanLogEntry(&logEntry);
}


inline void CEventLogger::DoLogError(REFIID riid, HRESULT hres, const CString& sMethodName, const CString& sError,const CString& sSourceFileName,WORD wLine,IUnknown* pUnk) const
{
   CString sDesc;
   sDesc.Format("%s ", sError);

   if (pUnk)
   {
      CString sServerError;
      GetIErrorInfo(pUnk, sServerError);
      sDesc += sServerError;
   }

   LOG_ENTRY logEntry;
   ::ZeroMemory(&logEntry, sizeof(logEntry));

   FillLogEntry(&logEntry, sMethodName,sSourceFileName,sDesc,wLine);

   logEntry.hres            = hres;
   logEntry.iidError        = riid;

   ILogbook* pLogbook  = NULL;
   hres = ::CoCreateInstance(CLSID_LogbookEventClass2, NULL, CLSCTX_ALL, IID_ILogbook2, (void **) &pLogbook);
   if (S_OK == hres)
   {
      pLogbook->LogError(&logEntry);
      pLogbook->Release();
   }

   CleanLogEntry(&logEntry);
}

///////////////////////////////////////////////////////////////////////////////
//Internal Helper Functions
inline void CEventLogger::GetIErrorInfo(IUnknown* pUnk, CString& sDescription) const
{
   if (NULL == pUnk)
   {
      sDescription = "NULL pUnk";
      return;
   }

   HRESULT     hres  = S_OK;
   IErrorInfo* pInfo = NULL;
   hres = pUnk->QueryInterface(IID_IErrorInfo, (void **) &pInfo);
   if (FAILED(hres))
   {
      sDescription = "Can't create IErrorInfo object";
      return;
   }

   BSTR bstrDescription;
   hres = pInfo->GetDescription(&bstrDescription);
   pInfo->Release();
   if (FAILED(hres))
   {
      sDescription = "Can't get description";
      return;
   }

   sDescription.Format("Server Error: %s", CString(bstrDescription));
}


inline GUID CEventLogger::GetTransactionID(void) const
{
   GUID guidTransactionID = GUID_NULL;
   HRESULT hres = S_OK;

   if(m_pObjectContextInfo != NULL)
   {
      hres = m_pObjectContextInfo->GetTransactionId(&guidTransactionID);
   }

   return guidTransactionID;
}

inline GUID CEventLogger::GetActivityID(void) const
{
   GUID guidActivityID = GUID_NULL;
   HRESULT hres = S_OK;

   if(m_pObjectContextInfo != NULL)
   {
      hres = m_pObjectContextInfo->GetActivityId(&guidActivityID);
   }

   return guidActivityID;
}

inline GUID CEventLogger::GetContextID(void) const
{
   GUID guidContextID = GUID_NULL;
   HRESULT hres = S_OK;

   if(m_pObjectContextInfo != NULL)
   {
      hres = m_pObjectContextInfo->GetContextId(&guidContextID);
   }

   return guidContextID;
}

inline void CEventLogger::FillLogEntry(LOG_ENTRY* pLogEntry, const CString& sMethodName, const CString& sSourceFileName,const CString& sDescription,WORD wLine) const
{
   SYSTEMTIME systemTime;
   ::GetSystemTime(&systemTime);
   ::SystemTimeToFileTime(&systemTime, &pLogEntry->eventTime);

   CString sStr;
   BOOL bres = FALSE;

   TCHAR ComputerName[MAX_COMPUTERNAME_LENGTH + 1];
   DWORD dwComputerNameLength = sizeof(ComputerName);
   bres = ::GetComputerName(ComputerName, &dwComputerNameLength);
   if (FALSE == bres)
   {
      sStr = "Can't get Computer name";
   }
   sStr = ComputerName;
   pLogEntry->bstrMachineName = sStr.AllocSysString();

   TCHAR lpFilename[MAX_PATH];
   bres = ::GetModuleFileName(AfxGetInstanceHandle(), lpFilename, MAX_PATH - 2);
   if (FALSE == bres)
   {
      sStr = "Can't get Module Name";
   }
   sStr = CEventLogger::FindPathInFileName(lpFilename);
   pLogEntry->bstrModuleName = sStr.AllocSysString();

   sStr = CEventLogger::FindPathInFileName(sSourceFileName);
   pLogEntry->bstrSourceFileName = sStr.AllocSysString();

   pLogEntry->dwProcessID        = ::GetCurrentProcessId();
   pLogEntry->dwThreadID         = ::AfxGetThread()->m_nThreadID;
   pLogEntry->guidActivityID     = GetActivityID();
   pLogEntry->guidTransactionID  = GetTransactionID();
   pLogEntry->guidContextID      = GetContextID();
   pLogEntry->dwLineNumber       = wLine;
   pLogEntry->bstrMethodName     = sMethodName.AllocSysString();
   pLogEntry->bstrDescription    = sDescription.AllocSysString();

   pLogEntry->hres = S_OK;
   pLogEntry->iidError  = IID_NULL;
}

inline void CEventLogger::CleanLogEntry(LOG_ENTRY* pLogEntry) const
{
   ::SysFreeString(pLogEntry->bstrDescription);
   ::SysFreeString(pLogEntry->bstrMachineName);
   ::SysFreeString(pLogEntry->bstrMethodName);
   ::SysFreeString(pLogEntry->bstrModuleName);
   ::SysFreeString(pLogEntry->bstrSourceFileName);
}
//////////////////////////////////////////////
//Helper functions:
inline void DoLogMethod(const CString& sMethodName, const CString& sSourceFileName, WORD wLine)
{
   CEventLogger eventLogger;
   eventLogger.DoLogMethod(sMethodName,sSourceFileName,wLine);
}
inline void DoLogError(REFIID riid, HRESULT hres, const CString& sMethodName, const CString& sError,const CString& sSourceFileName,WORD wLine,IUnknown* pUnk = NULL)
{
   CEventLogger eventLogger;
   eventLogger.DoLogError(riid,hres,sMethodName,sError,sSourceFileName,wLine,pUnk);
}
inline void DoLogEvent(const CString& sEvent)
{
   CEventLogger eventLogger;
   eventLogger.DoLogEvent(sEvent);
}

//Helper macros:
#ifndef THIS_FILE
#define LOG_THIS_FILE "Not available in current project setting"
#define LOG_LINE_ 0
#else
#define LOG_THIS_FILE THIS_FILE
#define LOG_LINE_ __LINE__
#endif


#define LOGMETHOD(x) DoLogMethod(x,LOG_THIS_FILE,(WORD)LOG_LINE_)
#define LOGERROR(i,h,m,s) DoLogError(i, h, m, s,LOG_THIS_FILE,(WORD)LOG_LINE_)
#define LOGEVENT(x)  DoLogEvent(x)
#define LOGERROR_AND_RETURN(i,h,m,s) if (FAILED(h)) { LOGERROR(i,h,m,s); return h; }


#endif//COM_LOG_BOOK