// CatalogAdmin.cpp : Implementation of CCatalogAdmin
#include "stdafx.h"
#include "Nukem.h"
#include "CatalogAdmin.h"
#include <comadmin.h>

/////////////////////////////////////////////////////////////////////////////
// CCatalogAdmin
CCatalogAdmin::CCatalogAdmin()
{
   m_pCatalog = NULL;
}
CCatalogAdmin::~CCatalogAdmin()
{
}
HRESULT CCatalogAdmin::FinalConstruct()
{
   HRESULT hres = S_OK;
         
   hres = ::CoCreateInstance(__uuidof(COMAdminCatalog), NULL, CLSCTX_SERVER, __uuidof(ICOMAdminCatalog),(void**)&m_pCatalog);

   return hres;
}
void CCatalogAdmin::FinalRelease()
{
   if(m_pCatalog != NULL)
   {
      m_pCatalog->Release();
   }
}


STDMETHODIMP CCatalogAdmin::ShutDown(BSTR bstrAppName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
   CString sAppName;
   	
   if(_bstr_t(bstrAppName) != _bstr_t(""))
   {
      return  m_pCatalog->ShutdownApplication(bstrAppName);
   }
   else//Shut down all the apps
   {
      HRESULT hres = S_OK;
      ICatalogObject* pApplication  = NULL;
      ICatalogCollection* pApplicationCollection = NULL;
      long nApplicationCount = 0;
      int i = 0;//Application index

      //Get the application collection
      hres = m_pCatalog->GetCollection(_bstr_t("Applications"),(IDispatch**)&pApplicationCollection);
      EXIT(hres);

      hres = pApplicationCollection->Populate();
      EXIT(hres);

      hres = pApplicationCollection->get_Count(&nApplicationCount);
      EXIT(hres);

      ATLASSERT(nApplicationCount > 0);

      for(i=0;i<nApplicationCount;i++)
      {
         //Get the current application

         hres = pApplicationCollection->get_Item(i,(IDispatch**)&pApplication);
         EXIT(hres);

         _variant_t varName;
         hres = pApplication->get_Name(&varName);
         EXIT(hres);

         _bstr_t bstrName(varName);

         if(bstrName != _bstr_t("System Application"))
         {
            hres = m_pCatalog->ShutdownApplication(bstrName);
         }
         RELEASE(pApplication);
      }
      exit(hres);
      exit:
         SAFERELEASE(pApplication);
         SAFERELEASE(pApplicationCollection);
      return hres;
   }
}

STDMETHODIMP CCatalogAdmin::Start(BSTR bstrAppName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	if(_bstr_t(bstrAppName) == _bstr_t(""))
   {
      return E_INVALIDARG;
   }

	return m_pCatalog->StartApplication(bstrAppName);
}
