// Nukem.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Nukem.h"
#include <objbase.h>
#include <atlbase.h>
#include <initguid.h>
#include "Nukem_i.c"
#include "CatalogAdmin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNukemApp

BEGIN_MESSAGE_MAP(CNukemApp, CWinApp)
	//{{AFX_MSG_MAP(CNukemApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNukemApp construction

CNukemApp::CNukemApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNukemApp object

CNukemApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNukemApp initialization
BOOL CNukemApp::InitInstance()
{
	if (!InitATL())
		return FALSE;

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		return TRUE;
	}


   USES_CONVERSION;
   ::CoInitialize(NULL);

   HRESULT hres = S_OK;
   ICatalogAdmin* pCatalogAdmin = NULL;

   ParseCommandLine(m_CmdInfo);
   
   hres = ::CoCreateInstance(CLSID_CatalogAdmin,NULL,CLSCTX_ALL,IID_ICatalogAdmin,(void**)&pCatalogAdmin);
	if(FAILED(hres))
   {
      ASSERT(0);
      return FALSE;
   }
   if(m_CmdInfo.m_AppList.IsEmpty())
   {
      hres = pCatalogAdmin->ShutDown(_bstr_t(""));
   }
   else
   {
      while(!m_CmdInfo.m_AppList.IsEmpty())
      {
         CString sAppName = m_CmdInfo.m_AppList.RemoveHead();
         _bstr_t bstrAppName = sAppName;
         hres = pCatalogAdmin->ShutDown(bstrAppName);

         switch(hres)
         {
            case COMADMIN_E_OBJECT_DOES_NOT_EXIST:
            {
               CString sMsg;
               sMsg.Format("The specified application name \"%s\" cannot be found",sAppName);
               AfxMessageBox(sMsg,MB_ICONEXCLAMATION);
            }
            case S_OK:
               continue;
            default:
               ASSERT(0);
         }
      }
   }

   pCatalogAdmin->Release();

   ::CoUninitialize();
   return FALSE;
}

	
CNukemModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
   OBJECT_ENTRY(CLSID_CatalogAdmin, CCatalogAdmin)
END_OBJECT_MAP()

LONG CNukemModule::Unlock()
{
	AfxOleUnlockApp();
	return 0;
}

LONG CNukemModule::Lock()
{
	AfxOleLockApp();
	return 1;
}
LPCTSTR CNukemModule::FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
	while (*p1 != NULL)
	{
		LPCTSTR p = p2;
		while (*p != NULL)
		{
			if (*p1 == *p)
				return CharNext(p1);
			p = CharNext(p);
		}
		p1++;
	}
	return NULL;
}


int CNukemApp::ExitInstance()
{
	if (m_bATLInited)
	{
		_Module.RevokeClassObjects();
		_Module.Term();
		CoUninitialize();
	}

	return CWinApp::ExitInstance();

}

BOOL CNukemApp::InitATL()
{
	m_bATLInited = TRUE;

	HRESULT hRes = CoInitialize(NULL);
	if (FAILED(hRes))
	{
		m_bATLInited = FALSE;
		return FALSE;
	}

	_Module.Init(ObjectMap, AfxGetInstanceHandle());
	_Module.dwThreadID = GetCurrentThreadId();

	LPTSTR lpCmdLine = GetCommandLine(); //this line necessary for _ATL_MIN_CRT
	TCHAR szTokens[] = _T("-/");

	BOOL bRun = TRUE;
	LPCTSTR lpszToken = _Module.FindOneOf(lpCmdLine, szTokens);
	while (lpszToken != NULL)
	{
		if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_NUKEM, FALSE);
			_Module.UnregisterServer(TRUE); //TRUE means typelib is unreg'd
			bRun = FALSE;
			break;
		}
		if (lstrcmpi(lpszToken, _T("RegServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_NUKEM, TRUE);
			_Module.RegisterServer(TRUE);
			bRun = FALSE;
			break;
		}
		lpszToken = _Module.FindOneOf(lpszToken, szTokens);
	}

	if (!bRun)
	{
		m_bATLInited = FALSE;
		_Module.Term();
		CoUninitialize();
		return FALSE;
	}

	hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
		REGCLS_MULTIPLEUSE);
	if (FAILED(hRes))
	{
		m_bATLInited = FALSE;
		CoUninitialize();
		return FALSE;
	}	

	return TRUE;

}
